<template>
  <div class="quiz-result-section">
    <!-- <main-header></main-header> -->

    <div class="content-section position-relative">
      <img
        src="@/assets/img/game_overlay.png"
        class="bg position-absolute w-100 top-0 start-0"
      />
      <div class="container py-5">
        <div class="row">
          <div class="col col-12 col-lg-3 order-lg-last">
            <custom-rightbar
              :top-rank-data="topRankData"
              :my-rank="myRank"
            ></custom-rightbar>
          </div>
          <div id="here" class="col col-12 col-lg-9">
            <div
              class="play-wrap bg-white position-relative mt-5 mt-lg-0"
              style="overflow: hidden"
            >
              <div class="px-2 px-lg-5 pt-5">
                <h2 class="text-dark">Congratulations!</h2>
                <p class="question-text text-dark py-4">
                  You have finished today's 1 minute quiz!
                </p>
                <div class="row mb-4">
                  <div class="col col-12 col-lg-4">
                    <h2 class="text-dark">Your record</h2>
                  </div>
                  <div class="col col-12 col-lg-7">
                    <div class="bg-danger p-3" style="border-radius: 32px">
                      <div
                        v-if="correctAnswer"
                        class="d-flex justify-content-between"
                      >
                        <p class="text-light">Correct answer:</p>
                        <p class="text-light fw-bold">{{ correctAnswer }}</p>
                      </div>
                      <div
                        v-if="totalQuest"
                        class="d-flex justify-content-between"
                      >
                        <p class="text-light">Total Question:</p>
                        <p class="text-light fw-bold">{{ totalQuest }}</p>
                      </div>
                      <div class="d-flex justify-content-between">
                        <p class="text-light">Ranking</p>
                        <p class="text-light fw-bold">
                          <span class="fw-bold" style="font-size: 22px">{{
                            myRank
                          }}</span
                          >/{{ totalPlayer }}
                        </p>
                      </div>
                      <div class="d-flex justify-content-between">
                        <p class="text-light">Start time:</p>
                        <p class="text-light fw-bold">{{ start_time }}</p>
                      </div>
                      <div class="d-flex justify-content-between">
                        <p class="text-light">End time:</p>
                        <p class="text-light fw-bold">{{ time_end }}</p>
                      </div>
                    </div>
                  </div>
                </div>
                <div class="d-flex justify-content-between">
                  <p class="text-dark fw-bold">Result announcement</p>
                  <p>April 5th, 2021</p>
                </div>
                <div
                  class="d-flex justify-content-end"
                  @click="$router.push('/').catch(() => {})"
                  style="cursor: pointer"
                >
                  <p class="text-danger display-6">&lt; Back</p>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- <main-footer></main-footer> -->
  </div>
</template>

<script>
// import MainHeader from "../components/MainHeader.vue";
// import MainFooter from "../components/MainFooter.vue";
import CustomRightbar from "../components/play-quiz-survey/CustomRightbar.vue";
// import UserInfo from "../components/play-quiz-survey/UserInfo.vue";
import moment from "moment";
import { apiCustomerPost } from "../services/baseApi.js";

export default {
  components: {
    // MainHeader,
    // MainFooter,
    CustomRightbar,
    // UserInfo
  },
  data() {
    return {
      totalQuest: 0,
      correctAnswer: 0,
      myRank: 0,
      totalPlayer: 0,
      start_time: 0,
      time_end: 0,
      topRankData: {},
    };
  },
  methods: {
    async getRank() {
      try {
        let user = JSON.parse(localStorage.getItem("user"));
        if (!user || !user.id) return;

        let datetimeEnd = moment().format("YYYY-MM-DD");
        let timeStamp = moment(datetimeEnd).valueOf();
        let body = {
          customer_id: user.id,
          date: timeStamp,
        };

        let res = await apiCustomerPost("quiz-reward/my-rank", body);

        if (res && res.data && res.data.status) {
          this.myRank = res.data.data.rank;
          this.totalPlayer = res.data.data.total;
        }
      } catch (error) {
        console.log(error);
      }
    },
    async getTopRank() {
      try {
        let datetimeEnd = moment().format("YYYY-MM-DD");
        let timeStamp = moment(datetimeEnd).valueOf();
        let body = {
          date: timeStamp,
        };

        let res = await apiCustomerPost("quiz-reward/top-rank", body);
        if (res && res.data && res.data.status) {
          this.topRankData = res.data.data;
        }
      } catch (error) {
        console.log(error);
      }
    },
  },
  mounted() {
    let query = this.$route.query;

    this.getRank();
    this.getTopRank();
    this.time_end = moment().format("YYYY-MM-DD hh:mm:ss");
    this.totalQuest = query["total-quest"];
    this.correctAnswer = query["correct-answer"];
    this.start_time = query["start_time"]
      ? query["start_time"]
      : moment(this.time_end, "YYYY-MM-DD hh:mm:ss")
          .add(-1, "m")
          .format("YYYY-MM-DD hh:mm:ss");
    let adsSection = document.getElementById("here");
    console.log(this.start_time);
    setTimeout(() => {
      adsSection.scrollIntoView({ block: "center" });
    }, 700);
  },
};
</script>

<style scoped>
.content-section img {
  height: 100%;
  object-fit: cover;
  z-index: -1;
}
.play-wrap {
  border-radius: 32px;
  padding: 1rem;
}
</style>
